<template>
  <div class="spinner-container" :class="{ light, 'without-overlay': withoutOverlay, filled }">
    <div class="spinner" :style="{ width: `${width}px`, height: `${height}px` }" />
  </div>
</template>

<script>
export default {
  name: 'Spinner',
  props: {
    light: {
      type: Boolean,
      default: false
    },
    withoutOverlay: {
      type: Boolean,
      default: false
    },
    filled: {
      type: Boolean,
      default: false
    },
    width: {
      type: Number,
      default: 100
    },
    height: {
      type: Number,
      default: 100
    }
  }
}
</script>

<style lang="scss" scoped>
.spinner-container {
  position: absolute;
  left: 0;
  top: 0;
  width: 100%;
  height: 100%;
  z-index: 99;
  display: flex;
  justify-content: center;
  align-items: center;

  background-color: rgba(0, 0, 0, 0.3);

  &.light {
    background-color: rgba(255, 255, 255, 0.5);
  }

  &.without-overlay {
    background-color: transparent;
  }

  &.filled {
    background: #fff;
  }
}

.spinner {
  background-image: url('../assets/loader.svg');
  background-size: contain;
  background-repeat: no-repeat;
  user-select: none;
}
</style>
